# ---------------------------------------------------------------------------
# - t_6000.als                                                              -
# - aleph:sio library test module                                           -
# ---------------------------------------------------------------------------
# - This program is free software;  you can redistribute it  and/or  modify -
# - it provided that this copyright notice is kept intact.                  -
# -                                                                         -
# - This program  is  distributed in  the hope  that it will be useful, but -
# - without  any  warranty;  without  even   the   implied    warranty   of -
# - merchantability or fitness for a particular purpose.  In no event shall -
# - the copyright holder be liable for any  direct, indirect, incidental or -
# - special damages arising in any way out of the use of this software.     -
# ---------------------------------------------------------------------------
# - copyright (c) 1999-2003 amaury darsch                                   -
# ---------------------------------------------------------------------------

# @info   aleph:sio directory test module
# @author amaury darsch

# get the library
interp:library "aleph-sio"

# create a temporary directory
const tmp (aleph:sio:Directory (aleph:sio:absolute-path "tmp"))
const exp (tmp:mkdir "examples")

# test the predicates
assert true (aleph:sio:directory-p tmp)
assert true (aleph:sio:directory-p exp)

# check the directories
assert true (aleph:sio:dir-p (tmp:get-name))
assert true (aleph:sio:dir-p (exp:get-name))

# check for files
const lsf (exp:get-files)
assert  0 (lsf:length)
tmp:rmdir "examples"

