# ---------------------------------------------------------------------------
# - t_6001.als                                                              -
# - aleph:sio library test module                                           -
# ---------------------------------------------------------------------------
# - This program is free software;  you can redistribute it  and/or  modify -
# - it provided that this copyright notice is kept intact.                  -
# -                                                                         -
# - This program  is  distributed in  the hope  that it will be useful, but -
# - without  any  warranty;  without  even   the   implied    warranty   of -
# - merchantability or fitness for a particular purpose.  In no event shall -
# - the copyright holder be liable for any  direct, indirect, incidental or -
# - special damages arising in any way out of the use of this software.     -
# ---------------------------------------------------------------------------
# - copyright (c) 1999-2003 amaury darsch                                   -
# ---------------------------------------------------------------------------

# @info   aleph:sio file test module
# @author amaury darsch

# get the library
interp:library "aleph-sio"

# create a temporary file
const tname (aleph:sio:absolute-path "tmp" (aleph:sio:tmp-name))
trans tfile (aleph:sio:OutputFile tname)

# open the input file and copy
const ifile (aleph:sio:InputFile "t_6001.als")
const ilen  (ifile:length)
while (ifile:valid-p) (tfile:write (ifile:read))
ifile:close
tfile:close

# reopen the temporary file and grab the length
trans tfile (aleph:sio:InputFile tname)
const tlen  (tfile:length)
tfile:close

# check for size and delete
assert ilen tlen
aleph:sio:rmfile tname


